#ifndef COMPLEX_INC
#define COMPLEX_INC

#include "Object.h"
#include "vision.h"

namespace Torch {

/** This class is designed to handle complex numbers

    @author Sebastien Marcel (marcel@idiap.ch)
    @version 2.0
    \Date
    @since 2.0
*/
class Complex : public Object
{
public:
	/// real part
	real r;

	/// imaginary part
	real i;

	//-----
	
	/** @name Lots of Constructors */
	//@{
	///
	Complex() { r=i=0.0; }

	///
	Complex(real r_, real i_) { r=r_; i=i_; }

	//@}
	
	/// destructor
	virtual ~Complex() {};

	//-----

	///
	sComplex get();

	///
	Complex conjg();

	///
	real Cabs();
	
	///
	Complex Csqrt();

	///
	void add(Complex a, Complex b);

	///
	void sub(Complex a, Complex b);
	
	///
	void mul(Complex a, Complex b);

	///
	void div(Complex a, Complex b);

	///
	void mul(real x, Complex a);
};

}

#endif 
