const char *help = "\
progname: mtest.cc\n\
code2html: This program tests matrix2D class methods.\n\
version: Torch3 vision2.0, 2004-2005\n\
(c) Dan Sunday (http:www.softsurfer.com) and Sebastien Marcel (marcel@idiap.ch)\n";

#include "general.h"
#include "Matrix2D.h"
#include "CmdLine.h"

using namespace Torch;

int main(int argc, char **argv)
{
 	real x1, y1;
 	real x2, y2;
	bool verbose;

	// Construct the command line
  	CmdLine cmd;
	cmd.setBOption("write log", false);
	
  	// Put the help line at the beginning
  	cmd.info(help);

  	cmd.addText("\nArguments:");
  	cmd.addRCmdArg("x1", &x1, "x1");
  	cmd.addRCmdArg("y1", &y1, "y1");
  	cmd.addRCmdArg("x2", &x2, "x2");
  	cmd.addRCmdArg("y2", &y2, "y2");
  	cmd.addText("\nOptions:");
  	cmd.addBCmdOption("-verbose", &verbose, false, "verbose");

	cmd.read(argc, argv);

	Matrix2D v;

	v.ptr[0][0] = x1; v.ptr[0][1] = x2;
	v.ptr[1][0] = y1; v.ptr[1][1] = y2;

	print("v = %s\n", v.sprint());

	Matrix2D u;
	Matrix2D w(1, 0, 0, 1);
	
	print("w = %s\n", w.sprint());

	// test operators
	u = -v;			print("-v \t\t= %s\n", u.sprint());
	u = 2*v;		print("2*v \t\t= %s\n", u.sprint());
	u = v + w;		print("v + w \t\t= %s\n", u.sprint());
	u = (v + w)/2;		print("(v + w)/2 \t= %s\n", u.sprint());
	u = v - w;		print("v - w \t\t= %s\n", u.sprint());
	u = (v - w)*0.5;	print("(v - w)*0.5 \t= %s\n", u.sprint());
	//a = v * w;		print("v * w = %g\n", a);
	print("\n");

}
