#ifndef LINE2D_INC
#define LINE2D_INC

#include "Point2D.h"

namespace Torch {

/** This class is designed to handle a 2D line

    A Line2D is infinite.

    @author Sebastien Marcel (marcel@idiap.ch)
    @author Dan Sunday (http://www.softsurfer.com/)
    @version 2.0
    \Date
    @since 1.0
*/
class Line2D : public geomObject
{
public:
	/// first point supporting the line
	Point2D P0;

	/// second point supporting the line
	Point2D P1;

	//-----
	
	/** @name constructors */
	//@{
	///
	Line2D() {};

	///
	Line2D(Point2D P0_, Point2D P1_) { P0 = P0_; P1 = P1_; }
	//@}
	
	/// destructor
	virtual ~Line2D() {};

	//-----

	///
	virtual void reset(Point2D P0_, Point2D P1_) { P0 = P0_; P1 = P1_; }

	/// save the line
	virtual void saveXFile(XFile *file);

	/// load a line
	virtual void loadXFile(XFile *file);

	/// return a line into a string
	virtual const char *sprint();

	//-----
	
	/// draw the line on an image
	virtual void draw(Image *image_, Color color_);

#ifdef HAVE_X11
	/// draw the line on a X11 display
	virtual void xdraw(Display *pDisplay_, Pixmap pixmap_, GC gc_, unsigned long color_);
#endif

};

}

#endif 
