#include "Triangle2D.h"

namespace Torch {
	
void Triangle2D::saveXFile(XFile *file)
{
   	P0.saveXFile(file);
   	P1.saveXFile(file);
   	P2.saveXFile(file);
}

void Triangle2D::loadXFile(XFile *file)
{
   	P0.loadXFile(file);
   	P1.loadXFile(file);
   	P2.loadXFile(file);
}

const char *Triangle2D::sprint()
{
	sprintf(buf_sprint, "[(%g, %g) (%g, %g) (%g, %g)]", 
	      		P0.x, P0.y, 
			P1.x, P1.y,
			P2.x, P2.y);

	return buf_sprint;
}

void Triangle2D::draw(Image *image, Color color)
{
	image->drawline(P0.x, P0.y, P1.x, P1.y, color);
	image->drawline(P1.x, P1.y, P2.x, P2.y, color);
	image->drawline(P2.x, P2.y, P0.x, P0.y, color);
}

}
