#include "Pearson.h"

namespace Torch {

//
mPearson::mPearson(int n_inputs_) : Metric(n_inputs_)
{
}
	
real mPearson::measure(real *sample_, real *template_)
{
	real x_mean = 0.0;
	real y_mean = 0.0;

	for(int i = 0 ; i < n_inputs ; i++)
	{
		x_mean += sample_[i];
		y_mean += template_[i];
	}
	x_mean /= (real) n_inputs;
	y_mean /= (real) n_inputs;

	real a = 0.0;
	real b = 0.0;
	real c = 0.0;

	for(int i = 0 ; i < n_inputs ; i++)
	{
		real z_x = sample_[i] - x_mean;
		real z_y = template_[i] - y_mean;

		a += z_x * z_y;
		b += z_x * z_x;
		c += z_y * z_y;
	}
	
	return 1.0 - a / (sqrt(b) * sqrt(c));
}

}
