#include "mProgressBar.h"

namespace Torch {

mProgressBar::mProgressBar(int n_, int N_)
{
	n = n_;
	N = N_;
	counter = 0;
	prefix_len = 12;
}

void mProgressBar::reset(char *prefix_)
{
	if(prefix_ != NULL) prefix_len = strlen(prefix_) + 13;

	counter = 0;

	if(prefix_ != NULL) print("%s progress bar [", prefix_);
	else print("progress bar [");
	for(int i = 0 ; i < N ; i++)
		print("*");
	print("]\n");

	for(int i = 0 ; i < prefix_len ; i++) print(" ");
	print(" [");

	counter = 0;
}

void mProgressBar::next(int counter_)
{
	real sample = (real) n / (real) N;

	if(counter_ > sample*counter)
	{
		print("|");
		counter++;
	}
}

void mProgressBar::stop()
{
	print("]\n");
}

mProgressBar::~mProgressBar()
{
}

}
